
#include <p30f2012.h>     // include dsPIC30F2012 header file

//===============================================================
// 1us delay

void wait(void) {
    asm("repeat #20");  // for 29.48MHz clock
    asm("nop");
}

//===============================================================
// t*10us delay

void delay10us(unsigned t) {
  unsigned i;

  for (i=0; i<t; i=i+1) {
    asm("repeat #284");  // for 29.48MHz clock
    asm("nop");
  }  
}

//===============================================================
// t*1ms delay

void delay1ms(unsigned t) {
  unsigned i, j;

  for (i=0; i<t; i=i+1) {
    for (j=0; j<10; j=j+1) {
      asm("repeat #2900");  // for 29.48MHz clock
      asm("nop");
    }
  }  
}

//===============================================================      

int main(void) {

  TRISBbits.TRISB6=0;
  while(1) {
    delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100); delay1ms(100);
    PORTBbits.RB6=~PORTBbits.RB6;
  }

}
